jif.extension

## Class JifDowngradeStmtExt

- java.lang.Object
- - polyglot.ast.Ext_c
  - - jif.ast.JifExt_c
    - - jif.extension.JifStmtExt_c
      - - jif.extension.JifDowngradeStmtExt

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, JifExt, JifStmtExt, polyglot.ast.Ext, polyglot.ast.NodeOps, polyglot.util.Copy<polyglot.ast.Ext>
  Direct Known Subclasses:
    JifDeclassifyStmtExt, JifEndorseStmtExt

      public abstract class JifDowngradeStmtExt
      extends JifStmtExt_c

  The Jif extension of the `DeclassifyStmt` node.
  See Also:
    `DeclassifyStmt`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface polyglot.util.Copy

      `polyglot.util.Copy.Util`

  - ### Field Summary

    - ### Fields inherited from class jif.extension.JifStmtExt_c

      `stmtDel`

    - ### Fields inherited from class jif.ast.JifExt_c

      `toJava, X`

    - ### Fields inherited from class polyglot.ast.Ext_c

      `ext, node, pred`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JifDowngradeStmtExt(ToJavaExt toJava)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JifContext` | `bodyContext(LabelChecker lc, JifContext A, Label downgradeFrom, Label downgradeTo)`
    `protected void` | `checkAdditionalConstraints(LabelChecker lc, JifContext A, Label labelFrom, Label labelTo, polyglot.util.Position pos)` Check any additional constraints
    `protected abstract void` | `checkAuthority(LabelChecker lc, JifContext A, Label labelFrom, Label labelTo, polyglot.util.Position pos)` Check the authority condition
    `protected polyglot.ast.Stmt` | `checkBody(LabelChecker lc, JifContext A, Label downgradeFrom, Label downgradeTo)`
    `protected abstract void` | `checkOneDimenOnly(LabelChecker lc, JifContext A, Label labelFrom, Label labelTo, polyglot.util.Position pos)` Check that only the integrity/confidentiality is downgraded, and not the other dimension.
    `protected void` | `checkPCconstraint(LabelChecker lc, JifContext A, Label pc, Label downgradeFrom, boolean boundSpecified)`
    `protected abstract void` | `checkRobustness(LabelChecker lc, JifContext A, Label labelFrom, Label labelTo, polyglot.util.Position pos)` Check the robustness condition
    `protected JifContext` | `declassifyConstraintContext(JifContext A)` TODO: document me!
    `protected PathMap` | `initPathMap(LabelChecker lc)` TODO: document me!
    `polyglot.ast.Node` | `labelCheckStmt(LabelChecker lc)`

    - ### Methods inherited from class jif.extension.JifStmtExt_c

      `copy, init, labelCheck, stmtDel, stmtDel`

    - ### Methods inherited from class jif.ast.JifExt_c

      `checkAndRemoveThrowType, checkThrowTypes, dump, getPathMap, integerBoundsCalculated, toJava, toJava, updatePathMap, X, X`

    - ### Methods inherited from class polyglot.ast.Ext_c

      `addDecls, buildTypes, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, ext, ext, extRewrite, extRewriteEnter, extRewriteOverride, initPred, lang, node, pred, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, print, printBlock, printSubStmt, superLang, throwTypes, toString, translate, typeCheck, typeCheckEnter, typeCheckOverride, visitChild, visitChildren, visitList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jif.ast.JifExt

      `integerBoundsCalculated, toJava, toJava, X, X`

    - ### Methods inherited from interface polyglot.ast.Ext

      `dump, ext, ext, initPred, node, pred`

    - ### Methods inherited from interface polyglot.ast.NodeOps

      `addDecls, buildTypes, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, extRewrite, extRewriteEnter, extRewriteOverride, lang, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, throwTypes, translate, typeCheck, typeCheckEnter, typeCheckOverride, visitChild, visitChildren, visitList`

- - ### Constructor Detail

    - #### JifDowngradeStmtExt

          public JifDowngradeStmtExt(ToJavaExt toJava)

  - ### Method Detail

    - #### declassifyConstraintContext

          protected JifContext declassifyConstraintContext(JifContext A)
                                                    throws polyglot.types.SemanticException

      TODO: document me!
      Throws:
        `polyglot.types.SemanticException`

    - #### labelCheckStmt

          public final polyglot.ast.Node labelCheckStmt(LabelChecker lc)
                                                 throws polyglot.types.SemanticException

      Specified by:
        `labelCheckStmt` in interface `JifStmtExt`
      Specified by:
        `labelCheckStmt` in class `JifStmtExt_c`
      Throws:
        `polyglot.types.SemanticException`

    - #### checkPCconstraint

          protected void checkPCconstraint(LabelChecker lc,
                                           JifContext A,
                                           Label pc,
                                           Label downgradeFrom,
                                           boolean boundSpecified)
                                    throws polyglot.types.SemanticException

      Throws:
        `polyglot.types.SemanticException`

    - #### checkBody

          protected polyglot.ast.Stmt checkBody(LabelChecker lc,
                                                JifContext A,
                                                Label downgradeFrom,
                                                Label downgradeTo)
                                         throws polyglot.types.SemanticException

      Throws:
        `polyglot.types.SemanticException`

    - #### bodyContext

          protected JifContext bodyContext(LabelChecker lc,
                                           JifContext A,
                                           Label downgradeFrom,
                                           Label downgradeTo)

    - #### initPathMap

          protected PathMap initPathMap(LabelChecker lc)
                                 throws polyglot.types.SemanticException

      TODO: document me!
      Throws:
        `polyglot.types.SemanticException`

    - #### checkOneDimenOnly

          protected abstract void checkOneDimenOnly(LabelChecker lc,
                                                    JifContext A,
                                                    Label labelFrom,
                                                    Label labelTo,
                                                    polyglot.util.Position pos)
                                             throws polyglot.types.SemanticException

      Check that only the integrity/confidentiality is downgraded, and not the other dimension.
      Parameters:
        `lc` -
        `labelFrom` -
        `labelTo` -
      Throws:
        `polyglot.types.SemanticException`

    - #### checkAuthority

          protected abstract void checkAuthority(LabelChecker lc,
                                                 JifContext A,
                                                 Label labelFrom,
                                                 Label labelTo,
                                                 polyglot.util.Position pos)
                                          throws polyglot.types.SemanticException

      Check the authority condition
      Parameters:
        `lc` -
        `labelFrom` -
        `labelTo` -
      Throws:
        `polyglot.types.SemanticException`

    - #### checkRobustness

          protected abstract void checkRobustness(LabelChecker lc,
                                                  JifContext A,
                                                  Label labelFrom,
                                                  Label labelTo,
                                                  polyglot.util.Position pos)
                                           throws polyglot.types.SemanticException

      Check the robustness condition
      Parameters:
        `lc` -
        `labelFrom` -
        `labelTo` -
      Throws:
        `polyglot.types.SemanticException`

    - #### checkAdditionalConstraints

          protected void checkAdditionalConstraints(LabelChecker lc,
                                                    JifContext A,
                                                    Label labelFrom,
                                                    Label labelTo,
                                                    polyglot.util.Position pos)
                                             throws polyglot.types.SemanticException

      Check any additional constraints
      Parameters:
        `lc` -
        `labelFrom` -
        `labelTo` -
      Throws:
        `polyglot.types.SemanticException`